#!/usr/bin/perl -X
# PP=/sciezka/do/skryptu/; PERL5LIB=$PP perl $PP/mtr.pl && chown -R www-data $PP/* && chgrp -R www-data $PP/*

use Config::IniFiles;	# aptitude install libconfig-inifiles-perl
use Data::Dumper;
use Getopt::Long;
use Time::Local;
use POSIX qw/strftime/;
use subFunction qw/delHash trim killprog path gdzieScript delCudzyslow delComment plikZapisz makeDir/;


 my $p_name = "MiniStatistics";
 my $p_version = "1.1.0";
 my $p_data = "11.09.2015";
 my $time = time();

 my %options = (
	"--quiet|q"		=>	\my $argQuiet,
	"--help|h|?"	=>	\my $argHelp,
	"--version|v"	=>	\my $argVersion,
	"--kill:i"		=>	\my $argKill,
 );
 Getopt::Long::config("no_ignore_case");
 GetOptions(%options);

   if($argHelp){
	print " $p_name for MiniStatistics, version $p_version [$p_data]\n";
	print " autor: seszu (seba\@kazuko.pl)\n";
	print "\n";
	print "-q, -?, --quiet	tłumi drukowanie dane na wyjściu; error, done\n";
	print "-h,     --help		drukuje pomoc\n";
	print "-v,     --version	drukuje wersje\n";
	print "        --kill=30	ubija wcześniej uruchomiony skrypt, który żyje dłużej niż określony czas   (default: 30min)\n";
	print "\n";
	exit 0;
   }

   if($argVersion) {
	print " $p_name, drukuje wersje $p_version [$p_data]\n";
	print " autor: seszu (seba\@kazuko.pl)\n";
	print " strona: http://kazuko.pl\n";
	print "\n";
	exit 0;
   }

  ## ubijanie procesów które żyją dłużej niż .. min
   if($argKill eq "0") { killprog($0, 30); } elsif($argKill) { killprog($0, $argKill); }

my $hostINI = new Config::IniFiles -file => path("/etc/MiniStatistics/hosts.ini");
print @Config::IniFiles::errors;
my $confINI = new Config::IniFiles -file => path("/etc/MiniStatistics/config.ini");
print @Config::IniFiles::errors;

my $cacheDIR = delCudzyslow(delComment($confINI->val("path", "cacheDIR")));


my $binMTR = delCudzyslow(delComment($confINI->val("mtr", "bin"))) || "/usr/bin/mtr";
my $countMTR = delCudzyslow(delComment($confINI->val("mtr", "count"))) || 10;

   if(delCudzyslow(delComment($confINI->val("www", "mtr"))) eq "true") {
	my $mtrDIR = makeDir($cacheDIR, "mtr_txt", 0750);

	   foreach my $li ($hostINI->Sections()) {
		my @arr = $hostINI->{v}{$li};
		   if(delCudzyslow(delComment(@arr->[0]{'mtr'})) eq "true") {
			my $host = $li;
			my $name = delCudzyslow(delComment(@arr->[0]{'name'}));
			$name = ($name ? $name : $li);


			   if(!$argQuiet) { print $host."\n"; }
			my $fullpath = makeDir($mtrDIR, $host, 0750);

			my $pam = 0;
			my $save = "";
			open (PING, "ping -nqc 1 $host|");
			   while (<PING>) {
				/\((\d+\.\d+\.\d+\.\d+)\)/ && ($ip = $1);
			   };
			close (PING);
			open(MTR, $binMTR." --report --no-dns --report-cycles $countMTR $ip|"); my @mtr = <MTR>; close (MTR); 


			   foreach my $out (@mtr) {
				my $ip = "";
				my $proc = "";
				my $hostx = "";
				$out =~ s/\s+$//;
				$out =~ m/(\d+\.\d+\.\d+\.\d+)/; $ip = $1;
				$out =~ m/(\d+\.\d+\%)/; $proc = $1;
				   if($ip and $proc =~ /^\d+\.\d+\%$/) {
					open (HOST, "host $ip|"); while (<HOST>) { /domain name pointer (.+)\.$/ && ($hostx = $1); }; close (HOST);
					$save .= $out."\t ".$hostx."\n";
				   } elsif($ip and !($proc =~ /^\d+\.\d+\%$/)) {
					open (HOST, "host $ip|"); while (<HOST>) { /domain name pointer (.+)\.$/ && ($hostx = $1); }; close (HOST);
					$save .= $out."\t\t\t\t\t\t\t   ".$hostx."\n";
				   } elsif($pam eq 0) {
					$save .= $out."\tDomain/Host\n";
					$pam = 1;
				   } else {
					$save .= $out."\n";
				   }
			   }

			plikZapisz($fullpath."/".$time.".txt", $save);
		   }
	   }
   }










