#!/usr/bin/perl -X
# PP=/sciezka/do/skryptu/; PERL5LIB=$PP perl $PP/mtr.pl && chown -R www-data $PP/* && chgrp -R www-data $PP/*

use Config::IniFiles;	# aptitude install libconfig-inifiles-perl
use Data::Dumper;
use RRDs;			# aptitude install librrdtool-oo-perl
use Getopt::Long;
use Time::Local;
use POSIX qw/strftime/;
use Term::ANSIColor qw(:constants);
use Mail::Sender;
use Email::MessageID;
use subFunction qw/delHash trim killprog path gdzieScript delCudzyslow delComment plikZapisz makeDir codePL delPL encode_header/;


 my $p_name = "MiniStatistics";
 my $p_version = "1.1.0";
 my $p_data = "11.09.2015";
 my $time = time();

 my %options = (
	"--quiet|q"		=>	\my $argQuiet,
	"--help|h|?"	=>	\my $argHelp,
	"--version|v"	=>	\my $argVersion,
	"--kill:i"		=>	\my $argKill,

	"--wykresy|w"	=>	\my $argWykresy,
 );
 Getopt::Long::config("no_ignore_case");
 GetOptions(%options);

   if($argHelp){
	print " $p_name, version $p_version [$p_data]\n";
	print " autor: seszu (seba\@kazuko.pl)\n";
	print "\n";
	print "-q, -?, --quiet	tłumi drukowanie dane na wyjściu; error, done\n";
	print "-h,     --help		drukuje pomoc\n";
	print "-v,     --version	drukuje wersje\n";
	print "        --kill=30	ubija wcześniej uruchomiony skrypt, który żyje dłużej niż określony czas   (default: 30min)\n";
	print "\n";
	print "-w,     --wykresy	czy ma generowac wykresy img\n";
	print "\n";
	exit 0;
   }

   if($argVersion) {
	print " $p_name for MiniStatistics, drukuje wersje $p_version [$p_data]\n";
	print " autor: seszu (seba\@kazuko.pl)\n";
	print " strona: http://kazuko.pl\n";
	print "\n";
	exit 0;
   }

  ## ubijanie procesów które żyją dłużej niż .. min
   if($argKill eq "0") { killprog($0, 30); } elsif($argKill) { killprog($0, $argKill); }

my $hostINI = new Config::IniFiles -file => path("/etc/MiniStatistics/MiniStatistics/hosts.ini");
print @Config::IniFiles::errors;
my $confINI = new Config::IniFiles -file => path("/etc/MiniStatistics//MiniStatistics/config.ini");
print @Config::IniFiles::errors;

my $cacheDIR = delCudzyslow(delComment($confINI->val("path", "cacheDIR")));
my $binPING = delCudzyslow(delComment($confINI->val("ping", "bin"))) || "/bin/ping";
my $countPING = delCudzyslow(delComment($confINI->val("ping", "count"))) || 2;

my $alertMail = delCudzyslow(delComment($confINI->val("alert", "alert-mail"))) || "false";
my $listMail = delCudzyslow(delComment($confINI->val("alert", "list-mail"))) || "";
my $alertSMS = delCudzyslow(delComment($confINI->val("alert", "alert-sms"))) || "false";
my $listTel = delCudzyslow(delComment($confINI->val("alert", "list-tel"))) || "";

my $smtpHost = delCudzyslow(delComment($confINI->val("serwer-mail", "smtp-host"))) || "";
my $smtpLogin = delCudzyslow(delComment($confINI->val("serwer-mail", "smtp-login"))) || "";
my $smtpPasswd = delCudzyslow(delComment($confINI->val("serwer-mail", "smtp-passwd"))) || "";
my $smtpAuth = delCudzyslow(delComment($confINI->val("serwer-mail", "smtp-auth"))) || "PLAIN";				# LOGIN, PLAIN
my $smtpPort = delCudzyslow(delComment($confINI->val("serwer-mail", "smtp-port"))) || "587";				# 25, 587, 465

my $fromMail = delCudzyslow(delComment($confINI->val("serwer-mail", "from-mail"))) || $smtpLogin;
my $fromName = delCudzyslow(delComment($confINI->val("serwer-mail", "from-name"))) || $smtpLogin;
my $mailTemat = delCudzyslow(delComment($confINI->val("serwer-mail", "mail-temat"))) || "alert";

my $modemPort = delCudzyslow(delComment($confINI->val("modem-gsm", "modem-port"))) || "/dev/ttyUSB0";		# ls -l /dev/ttyUSB* && ls -l /dev/ttyACM*
my $modemPIN = delCudzyslow(delComment($confINI->val("modem-gsm", "modem-pin"))) || "";

my $statusINI = ();

   if(-f $cacheDIR."/status.ini") {
	$statusINI = new Config::IniFiles -file => path($cacheDIR."/status.ini");
	print @Config::IniFiles::errors;
   }


my $coIle = 120;
my %sendDate = ();
my %hosts = ();
my %status = ();
my $saveHostStatus = "";


  ### Sprawdzanie parametrów maila
   if($alertMail eq "true") {
	   if(!$listMail) {
		   if(!$argGuiet) { print RED, " ERROR!", RESET; print " (parametr list-mail nie może być pusty)\n"; }
		$alertMail = "false";
	   }

	   if(!$smtpHost) {
		   if(!$argGuiet) { print RED, " ERROR!", RESET; print " (parametr smtp-host nie może być pusty)\n"; }
		$alertMail = "false";
	   }

	   if(!$smtpLogin) {
		   if(!$argGuiet) { print RED, " ERROR!", RESET; print " (parametr smtp-login nie może być pusty)\n"; }
		$alertMail = "false";
	   }

	   if(!$smtpPasswd) {
		   if(!$argGuiet) { print RED, " ERROR!", RESET; print " (parametr smtp-passwd nie może być pusty)\n"; }
		$alertMail = "false";
	   }

	   if($smtpAuth !~ /^(LOGIN|PLAIN|CRAM\-MD5|NTLM)$/) {
		   if(!$argGuiet) { print RED, " ERROR!", RESET; print " (parametr smtp-auth musi zawierać: LOGIN, PLAIN, CRAM-MD5 lub NTLM)\n"; }
		$alertMail = "false";
	   }

	   if(!$smtpPort) {
		   if(!$argGuiet) { print RED, " ERROR!", RESET; print " (parametr smtp-port nie może być pusty)\n"; }
		$alertMail = "false";
	   }

	   if($smtpPort !~ /^\d+$/) {
		   if(!$argGuiet) { print RED, " ERROR!", RESET; print " (parametr smtp-port musi być liczbą)\n"; }
		$alertMail = "false";
	   }


	   if($fromMail !~ /^.+\@.+\..+$/) {
		   if(!$argGuiet) { print RED, " ERROR!", RESET; print " (parametr from-mail nie jest mailem)\n"; }
		$alertMail = "false";
	   }
   }



  ### Sprawdzanie parametrów oraz połaczenia z modemem
   if($alertSMS eq "true") {
	   if(!$listTel) {
		   if(!$argGuiet) { print RED, " ERROR!", RESET; print " (parametr list-tel nie może być pusty)\n"; }
		$alertSMS = "false";
	   }

	   if(!$modemPort) {
		   if(!$argGuiet) { print RED, " ERROR!", RESET; print " (parametr modem-port nie może być pusty)\n"; }
		$alertSMS = "false";
	   }

	   if($modemPIN and $modemPIN !~ /^\d+$/) {
		   if(!$argGuiet) { print RED, " ERROR!", RESET; print " (parametr modem-pin musi być liczbą)\n"; }
		$alertSMS = "false";
	   }

	plikZapisz("/tmp/gammu_conf", "[gammu]\nport = $modemPort\nconnection = at");

	my $out = qx(gammu -c /tmp/gammu_conf identify);
	   if($out =~ /IMEI/) {
		   if(!($out =~ /SIM\sIMSI/)) {
			system qx( gammu -c /tmp/gammu_conf --entersecuritycode PIN $modemPIN 1>> /dev/null 2>> /dev/null);
		   }
		$out = qx(gammu -c /tmp/gammu_conf identify);
		   if(!($out =~ /SIM\sIMSI/)) {
			   if(!$argGuiet) { print RED, " ERROR!", RESET; print " (niepoprawny PIN - sekcja alert, parametr modem-pin)\n"; }
			$alertSMS = "false";
		   }

	   } elsif(($out =~ /Brak/ or $out =~ /Error/)) {
		   if(!$argGuiet) { print RED, " ERROR!", RESET; print " (prawdopodobnie źle podany ściezka w parametrze modem-port sekcja alert)\n"; }	# print "Odpowiedź od gammu:\n$out\n";
		$alertSMS = "false";
	   } else {
		   if(!$argGuiet) { print RED, " ERROR!", RESET; print "\n (brak programu gammu)\n"; }
		$alertSMS = "false";
	   }
   }













######### ZBIERANIE DANYCH #########
 my $rrdDIR = makeDir($cacheDIR, "ping_rrd", 0750);


   foreach my $li ($hostINI->Sections()) {
	my @arr = $hostINI->{v}{$li};
	my $host = $li;
	my $name = delCudzyslow(delComment(@arr->[0]{'name'}));
	$name = ($name ? $name : $li);
	my ($min, $avg, $max);
	   if(!$argQuiet) { print $host."\t"; }

	open (PING, $binPING." -nqc $countPING $host|");
	   while (<PING>) {
		/\((\d+\.\d+\.\d+\.\d+)\)/ && ($ip = $1);
		/(\d+)% packet loss/ && ($loss = $1);
		/= (.+)\/(.+)\/(.+)\/(.+) ms/ && (($min,$avg,$max,$mdev) = ($1,$2,$3,$4));
	   };
	close (PING);
	open (HOST, "host $ip|");
	   while (<HOST>) {
		/domain name pointer (.+)\.$/ && ($hosts{$host} = $1);
	   };
	close (HOST);


	   if(delCudzyslow(delComment(@arr->[0]{'wykres'})) eq "true" or delCudzyslow(delComment(@arr->[0]{'ping'})) eq "true") {
		   if(!-e $rrdDIR."/$host-ping.rrd") {
			RRDs::create($rrdDIR."/$host-ping.rrd",
					"-s ".$coIle,
					"DS:min:GAUGE:720:0:U",
					"DS:avg:GAUGE:720:0:U",
					"DS:max:GAUGE:720:0:U",
					"RRA:AVERAGE:0.5:1:262800",
					"RRA:MAX:0.5:1:5",
					"RRA:LAST:0.5:1:600"
			);
		   }

		RRDs::update( $rrdDIR."/$host-ping.rrd","N:$min:$avg:$max");

		   if(!-e $rrdDIR."/$host-loss.rrd") {
			RRDs::create($rrdDIR."/$host-loss.rrd",
					"-s ".$coIle,
					"DS:loss:GAUGE:720:0:U",
					"RRA:AVERAGE:0.5:1:262800",
					"RRA:MAX:0.5:1:5",
					"RRA:LAST:0.5:1:600"
			);
		   }

		RRDs::update($rrdDIR."/$host-loss.rrd","N:$loss");
	   }

	   if(!$argQuiet) { print $avg.($avg ? "ms" : "down")."\n"; }

	$status{$host}{'status'} = ($avg ? $avg : "down");
   }





   foreach my $li ($hostINI->Sections()) {
	my @arr = $hostINI->{v}{$li};

	my $host = $li;
	my $name = delCudzyslow(delComment(@arr->[0]{'name'}));
	$name = ($name ? $name : $li);

	   if(delCudzyslow(delComment(@arr->[0]{'alert'})) eq "true" and ($alertMail eq "true" or $alertSMS eq "true")) {
		   if($status{$host}{'status'} eq "down") {
			   if(delCudzyslow(delComment($statusINI->val($host, "alert"))) ne "send") {
				$saveHostStatus .= "[$host]\nname\t= \"$name\"\nhost\t= \"$host\"\nstatus\t= \"".($status{$host}{'status'} ? "up" : "down")."\"\nping\t= \"".($status{$host}{'status'} ? $status{$host}{'status'} : "down")."\"\nalert\t= \"send\"\nsend\t= \"down\"\n\n";
				$sendDate{'mail'}{'down'} .= " - $host ($name)\n";
				$sendDate{'sms'}{'down'} .= " - $host\n";


			   } else {
				$saveHostStatus .= "[$host]\nname\t= \"$name\"\nhost\t= \"$host\"\nstatus\t= \"".($status{$host}{'status'} ? "up" : "down")."\"\nping\t= \"".($status{$host}{'status'} ? $status{$host}{'status'} : "down")."\"\nalert\t= \"send\"\nsend\t= \"down\"\n\n";
			   }

		   } else {
			   if(delCudzyslow(delComment($statusINI->val($host, "alert"))) eq "send" and delCudzyslow(delComment($statusINI->val($host, "send"))) eq "down") {
				$saveHostStatus .= "[$host]\nname\t= \"$name\"\nhost\t= \"$host\"\nstatus\t= \"".($status{$host}{'status'} ? "up" : "down")."\"\nping\t= \"".($status{$host}{'status'} ? $status{$host}{'status'} : "down")."\"\nalert\t= \"send\"\nsend\t= \"up\"\n\n";
				$sendDate{'mail'}{'up'} .= " - $host ($name)\n"; 
				$sendDate{'sms'}{'up'} .= " - $host\n"; 

			   } else {
				$saveHostStatus .= "[$host]\nname\t= \"$name\"\nhost\t= \"$host\"\nstatus\t= \"".($status{$host}{'status'} ? "up" : "down")."\"\nping\t= \"".($status{$host}{'status'} ? $status{$host}{'status'} : "down")."\"\n\n";
			   }
		   }
	   } else {
		$saveHostStatus .= "[$host]\nname\t= \"$name\"\nhost\t= \"$host\"\nstatus\t= \"".($status{$host}{'status'} ? "up" : "down")."\"\nping\t= \"".($status{$host}{'status'} ? $status{$host}{'status'} : "down")."\"\n\n";
	   }
   }
 plikZapisz($cacheDIR."/status.ini", $saveHostStatus);









######### ALERT #########

   if(($sendDate{'mail'}{'up'} or $sendDate{'mail'}{'down'}) and ($alertMail eq "true" or $alertSMS eq "true")) {

	   if($alertMail eq "true") {
		$fromMail = ($fromName ? encode_header($fromName)." <$fromMail>" : $fromMail);
		my @maill = split(/\@/, $fromMailOrg);

		   foreach my $toMail (split(/\,/, $listMail)) {
			$toMail = trim($toMail);
			   if(!$argGuiet) { print "MAIL --> ".$toMail."\t"; }
			   if($toMail =~ /^[a-zA-Z0-9\.\-_\+]+\@[a-zA-Z0-9\.\-_]+\.[a-z]{2,4}$/) {
				my $sender = new Mail::Sender;
				   if($toMail =~ /^\+*\d{9,11}.*$/) {
					   if(ref($sender->MailMsg({
						smtp => $smtpHost,
						from => $fromMail,
						to => $toMail,
						subject => strftime('%d-%m-%Y %H:%M:%S',localtime($time)),
						msg => delPL(($sendDate{'sms'}{'down'} ? "nie działają:\n".$sendDate{'sms'}{'down'}."\n" : "").($sendDate{'sms'}{'up'} ? "zadziałały:\n".$sendDate{'sms'}{'up'} : "")),
						auth => $smtpAuth,
						authid => $smtpLogin,
						authpwd => $smtpPasswd,
						TLS_allowed => 0,
						messageid => "<".Email::MessageID->new(host => ((split(/\@/, $fromMailOrg))[1])).">",
					   }))) {
						$sender->Close;

						   if(!$argGuiet) { print GREEN, "ok\n", RESET; }
					   } elsif(!$argGuiet) {
						   if(!$argGuiet) { print RED, " ERROR!", RESET; print " ($Mail::Sender::Error)\n"; }
					   }

				   } else {
					   if(ref($sender->OpenMultipart({
						smtp => $smtpHost,
						from => $fromMail,
						to => $toMail,
						subject => $mailTemat." - ".strftime('%d-%m-%Y %H:%M:%S',localtime($time)),
						auth => $smtpAuth,
						authid => $smtpLogin,
						authpwd => $smtpPasswd,
						TLS_allowed => 0,
						messageid => "<".Email::MessageID->new(host => ((split(/\@/, $fromMailOrg))[1])).">",
					   }))) {

						$sender->Body({
							ctype => 'text/html', 
							encoding => 'quoted-printable', 
							charset => 'UTF-8', 
							msg => "<pre>".codePL(($sendDate{'mail'}{'down'} ? "<B>nie działają:</B>\n".$sendDate{'mail'}{'down'}."\n" : "").($sendDate{'mail'}{'up'} ? "<B>zadziałały:</B>\n".$sendDate{'mail'}{'up'} : ""))."</pre>\n", 
						});
						$sender->Close;

						   if(!$argGuiet) { print GREEN, "ok\n", RESET; }
					   } elsif(!$argGuiet) {
						   if(!$argGuiet) { print RED, " ERROR!", RESET; print " ($Mail::Sender::Error)\n"; }
					   }
				  }
			   } else {
				   if(!$argGuiet) { print RED, " ERROR!", RESET; print " (\"$toMail\" to nie jest mail)\n"; }
			   }
		   }
	   }



	   if($alertSMS eq "true") {
		   foreach my $toTel (split(/\,/, $listTel)) {
			   if($toTel =~ /^\+*\d{9,11}$/) {
				   if(!$argGuiet) { print "SMS --> ".$toTel."\n"; }

				my $string = "(".strftime('%d-%m-%Y %H:%M:%S',localtime($time)).")\n".($sendDate{'sms'}{'down'} ? "nie działają:\n".$sendDate{'sms'}{'down'}."\n" : "").($sendDate{'sms'}{'up'} ? "zadziałały:\n".$sendDate{'sms'}{'up'} : "");
				my $out = qx(gammu -c /tmp/gammu_conf sendsms TEXT $toTel -text "$string" 2>> /dev/null);
			   }
		   }
	   }


   }











######### GENEROWANIE WYKRESÓW #########

   if($argWykresy and delCudzyslow(delComment($confINI->val("www", "wykres"))) eq "true") {
	my $imgDIR = makeDir($cacheDIR, "wykres_img", 0750);

	   if(!$argQuiet) { print "wykres:\n"; }

	   foreach my $li ($hostINI->Sections()) {
		my @arr = $hostINI->{v}{$li};

		   if(delCudzyslow(delComment(@arr->[0]{'wykres'})) eq "true" or delCudzyslow(delComment(@arr->[0]{'ping'})) eq "true") {
			my $host = $li;
			my $name = delCudzyslow(delComment(@arr->[0]{'name'}));
			$name = ($name ? $name : $li);


			   if(!$argQuiet) { print "  ".$host."\n"; }

			my $lastTimePing = RRDs::last($rrdDIR."/$host-ping.rrd");
			my $lastTimeLoss = RRDs::last($rrdDIR."/$host-loss.rrd");

			## PING
			RRDs::graph($imgDIR."/$host-hour-ping.png",
					"-s -".(1*60*60),
					"-w 875",
					"-h 250",
					"--title=ping do $ip ".($hosts{$host} ? "- ".$hosts{$host}." " : "")."($host) - ostatnia godzina",
					"DEF:min=".$rrdDIR."/$host-ping.rrd:min:AVERAGE",
					"DEF:avg=".$rrdDIR."/$host-ping.rrd:avg:AVERAGE",
					"DEF:max=".$rrdDIR."/$host-ping.rrd:max:AVERAGE",
					"COMMENT:  Maxymalny    Średni     Minimalny    Ostatni                          ostatni wpis ".strftime('%d-%m-%Y %H\:%M\:%S',localtime($lastTimePing))."\\n",

					"GPRINT:min:MAX:%7.2lf%sms", "GPRINT:min:AVERAGE:%7.2lf%sms", "GPRINT:min:MIN:%7.2lf%sms", "GPRINT:min:LAST:%7.2lf%sms",
					"LINE1:min#00CF00FF:min ping \\n", "AREA:min#00CF0033",

					"GPRINT:avg:MAX:%7.2lf%sms", "GPRINT:avg:AVERAGE:%7.2lf%sms", "GPRINT:avg:MIN:%7.2lf%sms", "GPRINT:avg:LAST:%7.2lf%sms",
					"LINE2:avg#005199FF:avg ping \\n", "AREA:avg#00519933",

					"GPRINT:max:MAX:%7.2lf%sms", "GPRINT:max:AVERAGE:%7.2lf%sms", "GPRINT:max:MIN:%7.2lf%sms", "GPRINT:max:LAST:%7.2lf%sms",
					"LINE1:max#FF0101FF:max ping \\n", "AREA:max#FF010133",
			);
			RRDs::graph($imgDIR."/$host-day-ping.png",
					"-s -".(24*(1*60*60)),
					"-w 875",
					"-h 250",
					"--title=ping do $ip ".($hosts{$host} ? "- ".$hosts{$host}." " : "")."($host) - ostatnie 24h",
					"DEF:min=".$rrdDIR."/$host-ping.rrd:min:AVERAGE",
					"DEF:avg=".$rrdDIR."/$host-ping.rrd:avg:AVERAGE",
					"DEF:max=".$rrdDIR."/$host-ping.rrd:max:AVERAGE",
					"COMMENT:  Maxymalny    Średni     Minimalny    Ostatni                          ostatni wpis ".strftime('%d-%m-%Y %H\:%M\:%S',localtime($lastTimePing))."\\n",

					"GPRINT:min:MAX:%7.2lf%sms", "GPRINT:min:AVERAGE:%7.2lf%sms", "GPRINT:min:MIN:%7.2lf%sms", "GPRINT:min:LAST:%7.2lf%sms",
					"LINE1:min#00CF00FF:min ping \\n", "AREA:min#00CF0033",

					"GPRINT:avg:MAX:%7.2lf%sms", "GPRINT:avg:AVERAGE:%7.2lf%sms", "GPRINT:avg:MIN:%7.2lf%sms", "GPRINT:avg:LAST:%7.2lf%sms",
					"LINE2:avg#005199FF:avg ping \\n", "AREA:avg#00519933",

					"GPRINT:max:MAX:%7.2lf%sms", "GPRINT:max:AVERAGE:%7.2lf%sms", "GPRINT:max:MIN:%7.2lf%sms", "GPRINT:max:LAST:%7.2lf%sms",
					"LINE1:max#FF0101FF:max ping \\n", "AREA:max#FF010133",

			);
			RRDs::graph($imgDIR."/$host-week-ping.png",
					"-s -".(7*(24*(1*60*60))),
					"-w 875",
					"-h 250",
					"--title=ping do $ip ".($hosts{$host} ? "- ".$hosts{$host}." " : "")."($host) - ostatnie 7 dni",
					"DEF:min=".$rrdDIR."/$host-ping.rrd:min:AVERAGE",
					"DEF:avg=".$rrdDIR."/$host-ping.rrd:avg:AVERAGE",
					"DEF:max=".$rrdDIR."/$host-ping.rrd:max:AVERAGE",
					"COMMENT:  Maxymalny    Średni     Minimalny    Ostatni                          ostatni wpis ".strftime('%d-%m-%Y %H\:%M\:%S',localtime($lastTimePing))."\\n",

					"GPRINT:min:MAX:%7.2lf%sms", "GPRINT:min:AVERAGE:%7.2lf%sms", "GPRINT:min:MIN:%7.2lf%sms", "GPRINT:min:LAST:%7.2lf%sms",
					"LINE1:min#00CF00FF:min ping \\n", "AREA:min#00CF0033",

					"GPRINT:avg:MAX:%7.2lf%sms", "GPRINT:avg:AVERAGE:%7.2lf%sms", "GPRINT:avg:MIN:%7.2lf%sms", "GPRINT:avg:LAST:%7.2lf%sms",
					"LINE2:avg#005199FF:avg ping \\n", "AREA:avg#00519933",

					"GPRINT:max:MAX:%7.2lf%sms", "GPRINT:max:AVERAGE:%7.2lf%sms", "GPRINT:max:MIN:%7.2lf%sms", "GPRINT:max:LAST:%7.2lf%sms",
					"LINE1:max#FF0101FF:max ping \\n", "AREA:max#FF010133",

			);
			RRDs::graph($imgDIR."/$host-30_days-ping.png",
					"-s -".(30*(24*(1*60*60))),
					"-w 875",
					"-h 250",
					"--title=ping do $ip ".($hosts{$host} ? "- ".$hosts{$host}." " : "")."($host) - ostatnie 30 dni",
					"DEF:min=".$rrdDIR."/$host-ping.rrd:min:AVERAGE",
					"DEF:avg=".$rrdDIR."/$host-ping.rrd:avg:AVERAGE",
					"DEF:max=".$rrdDIR."/$host-ping.rrd:max:AVERAGE",
					"COMMENT:  Maxymalny    Średni     Minimalny    Ostatni                          ostatni wpis ".strftime('%d-%m-%Y %H\:%M\:%S',localtime($lastTimePing))."\\n",

					"GPRINT:min:MAX:%7.2lf%sms", "GPRINT:min:AVERAGE:%7.2lf%sms", "GPRINT:min:MIN:%7.2lf%sms", "GPRINT:min:LAST:%7.2lf%sms",
					"LINE1:min#00CF00FF:min ping \\n", "AREA:min#00CF0033",

					"GPRINT:avg:MAX:%7.2lf%sms", "GPRINT:avg:AVERAGE:%7.2lf%sms", "GPRINT:avg:MIN:%7.2lf%sms", "GPRINT:avg:LAST:%7.2lf%sms",
					"LINE2:avg#005199FF:avg ping \\n", "AREA:avg#00519933",

					"GPRINT:max:MAX:%7.2lf%sms", "GPRINT:max:AVERAGE:%7.2lf%sms", "GPRINT:max:MIN:%7.2lf%sms", "GPRINT:max:LAST:%7.2lf%sms",
					"LINE1:max#FF0101FF:max ping \\n", "AREA:max#FF010133",

			);
			RRDs::graph($imgDIR."/$host-year-ping.png",
					"-s -".(365*(24*(1*60*60))),
					"-w 875",
					"-h 250",
					"--title=ping do $ip ".($hosts{$host} ? "- ".$hosts{$host}." " : "")."($host) - ostatnie 365 dni",
					"DEF:min=".$rrdDIR."/$host-ping.rrd:min:AVERAGE",
					"DEF:avg=".$rrdDIR."/$host-ping.rrd:avg:AVERAGE",
					"DEF:max=".$rrdDIR."/$host-ping.rrd:max:AVERAGE",
					"COMMENT:  Maxymalny    Średni     Minimalny    Ostatni                          ostatni wpis ".strftime('%d-%m-%Y %H\:%M\:%S',localtime($lastTimePing))."\\n",

					"GPRINT:min:MAX:%7.2lf%sms", "GPRINT:min:AVERAGE:%7.2lf%sms", "GPRINT:min:MIN:%7.2lf%sms", "GPRINT:min:LAST:%7.2lf%sms",
					"LINE1:min#00CF00FF:min ping \\n", "AREA:min#00CF0033",

					"GPRINT:avg:MAX:%7.2lf%sms", "GPRINT:avg:AVERAGE:%7.2lf%sms", "GPRINT:avg:MIN:%7.2lf%sms", "GPRINT:avg:LAST:%7.2lf%sms",
					"LINE2:avg#005199FF:avg ping \\n", "AREA:avg#00519933",

					"GPRINT:max:MAX:%7.2lf%sms", "GPRINT:max:AVERAGE:%7.2lf%sms", "GPRINT:max:MIN:%7.2lf%sms", "GPRINT:max:LAST:%7.2lf%sms",
					"LINE1:max#FF0101FF:max ping \\n", "AREA:max#FF010133",

			);


			## LOSS
			RRDs::graph($imgDIR."/$host-hour-loss.png",
					"-s -".(1*60*60),
					"-w 875",
					"-h 250",
					"--title=loss do $ip ".($hosts{$host} ? "- ".$hosts{$host}." " : "")."($host) - ostatnia godzina",
					"DEF:loss=".$rrdDIR."/$host-loss.rrd:loss:AVERAGE",
					"COMMENT:  Maxymalny    Średni     Minimalny    Ostatni                          ostatni wpis ".strftime('%d-%m-%Y %H\:%M\:%S',localtime($lastTimeLoss))."\\n",

					"GPRINT:loss:MAX:%7.2lf%s", "GPRINT:loss:AVERAGE:%7.2lf%s", "GPRINT:loss:MIN:%7.2lf%s", "GPRINT:loss:LAST:%7.2lf%s",
					"LINE1:loss#FF0101FF:loss [%]\\n", "AREA:loss#FF010133",
			);
			RRDs::graph($imgDIR."/$host-day-loss.png",
					"-s -".(24*(1*60*60)),
					"-w 875",
					"-h 250",
					"--title=loss do $ip ".($hosts{$host} ? "- ".$hosts{$host}." " : "")."($host) - ostatnie 24h",
					"DEF:loss=".$rrdDIR."/$host-loss.rrd:loss:AVERAGE",
					"COMMENT:  Maxymalny    Średni     Minimalny    Ostatni                          ostatni wpis ".strftime('%d-%m-%Y %H\:%M\:%S',localtime($lastTimeLoss))."\\n",

					"GPRINT:loss:MAX:%7.2lf%s", "GPRINT:loss:AVERAGE:%7.2lf%s", "GPRINT:loss:MIN:%7.2lf%s", "GPRINT:loss:LAST:%7.2lf%s",
					"LINE1:loss#FF0101FF:loss [%]\\n", "AREA:loss#FF010133",
			);
			RRDs::graph($imgDIR."/$host-week-loss.png",
					"-s -".(7*(24*(1*60*60))),
					"-w 875",
					"-h 250",
					"--title=loss do $ip ".($hosts{$host} ? "- ".$hosts{$host}." " : "")."($host) - ostatnie 7 dni",
					"DEF:loss=".$rrdDIR."/$host-loss.rrd:loss:AVERAGE",
					"COMMENT:  Maxymalny    Średni     Minimalny    Ostatni                          ostatni wpis ".strftime('%d-%m-%Y %H\:%M\:%S',localtime($lastTimeLoss))."\\n",

					"GPRINT:loss:MAX:%7.2lf%s", "GPRINT:loss:AVERAGE:%7.2lf%s", "GPRINT:loss:MIN:%7.2lf%s", "GPRINT:loss:LAST:%7.2lf%s",
					"LINE1:loss#FF0101FF:loss [%]\\n", "AREA:loss#FF010133",
			);
			RRDs::graph($imgDIR."/$host-30_days-loss.png",
					"-s -".(30*(24*(1*60*60))),
					"-w 875",
					"-h 250",
					"--title=loss do $ip ".($hosts{$host} ? "- ".$hosts{$host}." " : "")."($host) - ostatnie 30 dni",
					"DEF:loss=".$rrdDIR."/$host-loss.rrd:loss:AVERAGE",
					"COMMENT:  Maxymalny    Średni     Minimalny    Ostatni                          ostatni wpis ".strftime('%d-%m-%Y %H\:%M\:%S',localtime($lastTimeLoss))."\\n",

					"GPRINT:loss:MAX:%7.2lf%s", "GPRINT:loss:AVERAGE:%7.2lf%s", "GPRINT:loss:MIN:%7.2lf%s", "GPRINT:loss:LAST:%7.2lf%s",
					"LINE1:loss#FF0101FF:loss [%]\\n", "AREA:loss#FF010133",
			);
			RRDs::graph($imgDIR."/$host-year-loss.png",
					"-s -".(365*(24*(1*60*60))),
					"-w 875",
					"-h 250",
					"--title=loss do $ip ".($hosts{$host} ? "- ".$hosts{$host}." " : "")."($host) - ostatnie 365 dni",
					"DEF:loss=".$rrdDIR."/$host-loss.rrd:loss:AVERAGE",
					"COMMENT:  Maxymalny    Średni     Minimalny    Ostatni                          ostatni wpis ".strftime('%d-%m-%Y %H\:%M\:%S',localtime($lastTimeLoss))."\\n",

					"GPRINT:loss:MAX:%7.2lf%s", "GPRINT:loss:AVERAGE:%7.2lf%s", "GPRINT:loss:MIN:%7.2lf%s", "GPRINT:loss:LAST:%7.2lf%s",
					"LINE1:loss#FF0101FF:loss [%]\\n", "AREA:loss#FF010133",
			);
		   }
	   }
   }



